/* tiger.h  -  The TIGER hash function
 * Copyright (C) 1998 Free Software Foundation, Inc.
 *
 * This file was originally part of GNUPG, but was modified by Tom Zerucha
 * for use in OpenPGP.
 * It is covered under the GNU Public Licence - write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * or see www.gnu.org
 */

#ifndef TIGER_H
#define TIGER_H

typedef struct {
  unsigned long long a, b, c;
  unsigned long nblocks;
  unsigned char buf[64];
  int count;
} TIGER_CTX;

void TIGER_Init(TIGER_CTX * c);
void TIGER_Update(TIGER_CTX * hd, unsigned char *inbuf, int inlen);
void TIGER_Final(void *buf, TIGER_CTX * hd);

#endif
